
-- Let's translate various mods to russian!

--  !    ?
-- :   ,    modinfo.
-- , "Beefalo Milk"  ..

local _G = _G or GLOBAL --  !


--       .
--    ,  .
local GetGlobal=function(gname,default)
	local res=_G.rawget(_G,gname)
	if default and not res then
		_G.rawset(_G,gname,default)
		return false
	else
		return res
	end
end

--     ,    Start.
--    .
--     -  .
local post_init_fns={}
local function AddPostInit(fn,char_name)
	--table.insert(post_init_fns,fn)
	table.insert(post_init_fns,(char_name and {fn,char_name} or {fn}))
end


--   
local io=_G.io
local save_tables={}
GetGlobal("arr",function(o,t,f)
	if not t or type(t)~="string" or not f then 
		t=""
		save_tables={}
		f=io.open("log.txt","w")
	end
	if save_tables[o] then
		--print(t.."[recursive]")
		f:write(t.."[recursive]\n")
		return false
	end
	save_tables[o]=1
	for k,v in pairs(o) do
		local kk=type(k)=="string" and k or ("[table:"..tostring(k).."]")
		--print(t..kk.." = "..tostring(v))
		f:write(t.."*"..kk.."("..type(v)..") = "..tostring(v).."\n")
		if type(v)=="table" and k~="parent" then _G.arr(v,t.."\t",f) end
	end
	if(t=="") then
		f:close()
	end
end)


-----------------------------



--   
GetGlobal("IsDLCEnabled",function(x) return false end)

-- 
local s,require,act = _G.STRINGS,_G.require,_G.ACTIONS
local nm,rec,ch = s.NAMES,s.RECIPE_DESC,s.CHARACTERS
local gen = ch.GENERIC
local gendesc = gen.DESCRIBE
local DLC = GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS)
local player; -- .

--
local willow,wolfgang,wendy,wx78 = ch.WILLOW.DESCRIBE,ch.WOLFGANG.DESCRIBE,ch.WENDY.DESCRIBE,ch.WX78.DESCRIBE
local woodie,maxwell,wicker = ch.WOODIE.DESCRIBE,ch.WAXWELL.DESCRIBE,ch.WICKERBOTTOM.DESCRIBE
--DLC characters
local wath = DLC and ch.WATHGRITHR.DESCRIBE or {} --WATHGRITHR
local webber = ch.WEBBER and ch.WEBBER.DESCRIBE or {} --  .     DLC.


--DEBUG -----------------------------
GetGlobal("p",function(s)
	_G.print(tostring(s))
end)

GetGlobal("d",function(s)
	_G.DebugSpawn(s)
end)

-- .
--local log_f;
local status=""
local function logg(s)
	--if not log_f then log_f=io.open("debug.txt","w") end
	--f:write(s.."\n")
	status=status..s..", "
end


local errors = ""
function err(s)
	errors = errors..tostring(s).."!, "
	_G.print("ERROR: "..tostring(s).."!")
end

local d_rus_mods = {} --  ,    . 1 = , 0 = 

--array list
--assoc array list
GetGlobal("a",function(t)
	for k,v in pairs(t) do
		_G.print(tostring(k).." = "..tostring(v))
	end
end)

local conf_options = {} --   
local current_mod_name = "" --   (   )
--   
function AddConfig(config,mod_name)
	if not mod_name then mod_name = current_mod_name end
	conf_options[mod_name]=config
end

--   .
--           dest,
--    ,   dest  
local function StructCopy(src,dest)
	--local cnt=0
	for k,v in pairs(src) do
		if(type(v)=="table") then
			if(not dest[k] or type(dest[k])~="table")then 
				dest[k]={} --   ,   .
			end
			--cnt=cnt+
			StructCopy(v,dest[k])
		elseif dest[k] and v then
			dest[k]=v
			--cnt=cnt+1
		end
	end
	--return cnt
end
GetGlobal("struct",StructCopy) --  

--------------------------------------
--Detecting enabled mods
local mod_names={}  --   (   )
local mod_names_nover={} --     (    )
function GetAllModNames()
	for _, mod in ipairs( _G.ModManager.mods ) do
		--table.insert(all,mod.modinfo.name)
		if (mod.modinfo.name) then
			mod_names[mod.modinfo.name]=true
			local s=string.match(mod.modinfo.name,"^(.-)([0-9%._ ]+)$")
			if s then
				mod_names_nover[s]=mod.modinfo.name --    
				-- true     (    )
			else
				mod_names_nover[mod.modinfo.name]=mod.modinfo.name
			end
		end
	end
end
GetAllModNames()

--       
function IsModEnabled(name,short_name)
	current_mod_name=name --      
	local res=mod_names[name] or false
	if(short_name)then d_rus_mods[short_name]=res end
	return res
end

--  .     
function IsModEnabledNoVer(name,short_name)
	current_mod_name=name --      
	local s=string.match(name,"^(.-)([0-9%._ ]+)$")
	if s then
		name=s -- ,     
	end
	local res=false
	if mod_names_nover[name] then
		res=true
		current_mod_name=mod_names_nover[name] --    
	end
	if(short_name)then d_rus_mods[short_name]=res end
	return res
end

local is_rus = IsModEnabled("Russian Language Pack")

--unsupported feature
GetGlobal("GAMELANGUAGE","EN")
_G.GAMELANGUAGE = is_rus and "RU" or _G.GAMELANGUAGE

----------------------------------------
-- " ".     ,    .
if not GetGlobal("LanguageTranslator") or not GetGlobal("russiannames")
	or not GetGlobal("NamesGender") or not GetGlobal("shouldbecapped") then
	is_rus=false
end

--   .
-- , ?    .   -  ,     ().
if IsModEnabled("Always On Status") then
	--  Always On Status     .
	--    ,    .
	local FixSwitch=function(player)
		local switch = GLOBAL.require "components/switch"
		inst:AddComponent("switch")
	end
	if IsModEnabled("Whimsy the Goth") then
		--AddPrefabPostInit("whimsy", FixSwitch)
	end


end

-------------------------------------------------------------------------------------------------------
----     -------------------------------------------------------------------------------------------------------

if is_rus then --    .   ,  , ..   break

--DEBUG
GetGlobal("t",function(s)
	_G.testname(s)
	--_G.print(".......................")
end)

--   
function StringTime(n,s)
	local pl_type=n%10==1 and n%100~=11 and 1 or(n%10>=2 and n%10<=4 and(n%100<10 or n%100>=20)and 2 or 3)
	if s=="" then
		local days = {"","",""}
		return n.." "..days[pl_type]
	else
		return n.." "..s
	end
end


--    
function RandomString(tbl)
	return tbl[math.random(#tbl)]
end


--    
--struct_original  
--struc_trans   (  )
local function DumpText(sign,struct_original,struc_trans)
	if not struct_original then
		struct_original = require("speech_"..sign)
	end
	if not struc_trans then
		struc_trans = require("rus_"..sign)
	end
	local f_nota = io.open(sign.."_notabenoid.txt","w") --   
	local f_nums = io.open(sign.."_nums.txt","w") -- 
	local test=GetGlobal("testname2")
	local function an(o,t,it,prefix,wrd) --   
		if not t then t={} end
		if not prefix then prefix="" end
		for k,v in pairs(o) do
			if (type(v)=="table") then
				local i=(k=="DESCRIBE") and 1 or false
				local w=it and k or wrd
				an(v,t[k],i,prefix..k..".",w)
			else
				f_nota:write(
					(it and test(k) or (wrd and test(wrd) or ""))
					..prefix..k.." = \""..v:gsub("\n","\\n").."\""
					..((t[k] and t[k]~=v)and (" ("..t[k]:gsub("\n","\\n")..")") or "")
					.."\n"
				)
				f_nums:write(prefix..k.."\n")
			end
		end
	end
	an(struct_original,struc_trans)
	f_nota:close()
	f_nums:close()
end
GetGlobal("dump",DumpText)
--local sat = require "or_sat"
--local satt = require "rus_sat"
--DumpText("sat",sat,satt)




--    RLP!
local genders={"he","he2","she","it","plural", --number
	he="he",he2="he2",she="she",it="it",plural="plural"}; --genders[99]="plural";
function RegisterRussianName(key,val,gender,walk_to,default_act,capped)
	if (not is_rus) then return false end --  .
	nm[string.upper(key)]=val
	if(walk_to==1) then walk_to=val end
	if(default_act==1) then default_act=val end
	_G.LanguageTranslator.languages.ru["STRIN".."GS.NAMES."..string.upper(key)] = val
	if(gender)then
		if(genders[gender]) then
			_G.NamesGender[genders[gender]][string.lower(key)]=true
		else
			err(tostring(key).."["..tostring(gender).."]")
		end
	end
	if (walk_to and walk_to~=0)or(default_act and default_act~=0) then
		if (not _G.russiannames[val]) then _G.russiannames[val]={} end
		if(walk_to and walk_to~=0)then _G.russiannames[val]["WALKTO"]=walk_to end
		if(default_act and default_act~=0)then _G.russiannames[val]["DEFAULTACTION"]=default_act end
	end
	if(capped and capped~=0) then _G.shouldbecapped[string.lower(key)]=1 end
end
local ch_nm=RegisterRussianName;
--_G.reg_rus=ch_nm; --jj


--      .
-- ,  ,      ,      .
--(force) f_rec  f_gen -          .
local glob_nm={} --    
local mk_nm = function(key,val,gender,walk_to,default_act,capped,f_rec,f_gen)
	--    :
	ch_nm(key,val,gender,walk_to,default_act,capped)
	--  "":
	AddPrefabPostInit(string.lower(key),function(inst)
		if(inst and inst.name)then
			inst.name=val
		end
		-- ,   ...  !
		nm[string.upper(key)]=val
		--if f_nm and f_nm~=0 then nm[string.upper(key)]=val end
		if (f_rec and f_rec~=0) then rec[string.upper(key)]=f_rec end
		if (f_gen and f_gen~=0) then gendesc[string.upper(key)]=f_gen end
	end)
	-- STRINGS  :
	--AddPostInit(function()
	--	nm[string.upper(key)]=val
	--end)
	--    
	glob_nm[string.upper(key)]=val
end
local mk=mk_nm;

-- ,      
local glob_rec={}
local mk_rec = function(key,val)
	rec[key]=val --  
	glob_rec[key]=val --     (  Start)
end

local glob_gen={}
local mk_gen = function(key,val)
	gendesc[key]=val
	glob_gen[key]=val
end




--  - +.     ,    .     .
--     ,   .
local trans = GetModConfigData("translate")

--       ( ).
--    - 4   + tech = .  (   a2   a3)
--     :
local slang_order={{1,2,3,4},{2,1,3,4},{3,2,4,1},{4,3,2,1}}
local slang=function(a1,a2,a3,a4,tech)
	local a={a1,a2,a3,a4}
	if (tech and type(tech)=="string" and ((a3 and a3~=0) or (a4 and a4~=0))) then
		--  "",     .
		if a3==0 or not a3 then
			if(type(a4)=="table") then -- ,     
				a[2]=a4
				for i=1,#a4 do
					a[2][i]=a4[i].." "..tech
				end
			else --  
				a[2]=a4.." "..tech
			end
		else
			if(type(a3)=="table") then
				a[2]=a3
				for i=1,#a3 do
					a[2][i]=a3[i].." "..tech
				end
			else
				a[2]=a3.." "..tech
			end
		end
	end
	for i=1,4 do
		local j=slang_order[trans][i] --   
		if (a[j] and a[j]~=0) then return a[j] end
	end
	--   -  .
	--jj
	err("slang")
	return "false"
end
_G.slang=slang

--------------------------------------------------------------------------------------------------------------

-- normal == 2
if GetModConfigData("goose")=="1" then
	ch_nm("MOOSE1","","he2","","",1)
	ch_nm("MOOSE2","","he2","","",1)
	_G.shouldbecapped["moose"]=1
end

if GetModConfigData("engine")=="engine" then
	ch_nm("RESEARCHLAB2"," ","he"," ",1) --,"he") --default
else
	ch_nm("RESEARCHLAB2"," ","she")
end

local deerclops=GetModConfigData("deerclops")
if deerclops>1 then
	if deerclops==2 then
		mk("DEERCLOPS","",2,"","",1)
	elseif deerclops==3 then
		mk("DEERCLOPS","",2,"","",1)
	elseif deerclops==4 then
		mk("DEERCLOPS","",2,"","",1)
	end
end

if GetModConfigData("eyebrella")==2 then
	ch_nm("EYEBRELLAHAT","",3)
end

if GetModConfigData("silk")==2 then
	ch_nm("SILK","ظ",1)
end


-------------------------------------------------------------------------------------------------------------

if IsModEnabled("Madman's Fighting Pack","MM") then --Madman's Fighting Pack
	--id: 172090600
	-- ,   modmain.lua
	--MAX "    . 50*150 test1 test2 test3 test4 test5 test6 test7" ~ 86 
	ch_nm("HOUNDSBITE"," ","she")
	rec.HOUNDSBITE = "    ."..(trans<3 and " 50*150" or "")
	gendesc.HOUNDSBITE = "  ,    ."

	ch_nm("GOLDSWORD"," ","he")
	rec.GOLDSWORD = "  ,  ."..(trans<3 and " 75*100" or "")
	gendesc.GOLDSWORD = " ,    ."

	ch_nm("ICEBLADE"," ","he")
	rec.ICEBLADE = "   ."..(trans<3 and " 50*40" or "")
	gendesc.ICEBLADE = ",   ,   ."

	ch_nm("MARBLBLADE"," ","he")
	rec.MARBLBLADE = "    - ."..(trans<3 and " 110*200" or "")
	gendesc.MARBLBLADE = "       ."

	ch_nm("GOLDARMOR"," ","she")
	rec.GOLDARMOR = ", ,  ."..(trans<3 and " 900/90%" or "")
	gendesc.GOLDARMOR = ",   , ,  ."

	nm.GOLDHELM = " "
	rec.GOLDHELM = "   ...  ."..(trans<3 and " 850/90%" or "")
	gendesc.GOLDHELM = "   ."

	nm.STRONGSWORD = " "
	rec.STRONGSWORD =("  ."..(trans==2 and " 150%  ,   ." or "")..(trans<3 and " 72*150" or ""))
	gendesc.STRONGSWORD = "    .    ."
end

--*******************************************************************************************************************

if IsModEnabled("Display Food Values","DFV") then --Display Food Values
	--id: 170030148
	--priority: 3
	--   ,   . , ,  .
	--require "modmain_Spanish"
	--_G.s_test=s.DFV_LANG
	if(s.DFV_LANG~="RU") then
		s.DFV_LANG = "RU"
		s.DFV_HUNGER = ""
		s.DFV_HEALTH = ""
		s.DFV_SANITY = ""
		s.DFV_SPOILSOON = " "
		s.DFV_SPOILIN = " "
		s.DFV_SPOILDAY = ""
		local DFV_MIN=GetModConfigData("DFV")
		if DFV_MIN>1 then
			s.DFV_MIN = (DFV_MIN==2 and true or false)
		end
	end
end

--*******************************************************************************************************************

if IsModEnabled("Camp Cuisine","CC1") then -- Camp Cuisine Series --------------------
	--id: 181089286
	--  .
	mk("SPICE"," ","plural"," "," ")
	rec.SPICE = "   " --jj
	mk("BANNANACREME","   ")
	mk("BATBITES","   ","she","   ","   ")
	mk("BRATWURST"," ","he"," "," ")
	mk("CAKE","","it")
	mk("CAVERNSTEW"," ","it")
	mk("CUPCAVES"," ","plural")
	mk("FISHEADSTEW","  ","she","  ","  ")
	mk("GRILLEDSHROOMS"," ","she")
	mk("GRILLEDCORN"," ","she")
	mk("LASAGNA","","she","","")
	mk("MUSHEDSHROOMS"," ","she")
	mk("PUNKINPIE"," ")
	mk("SPIDERBITES"," ","plural")
	mk("VEGGIMEATSTEW"," ","it")
end
if IsModEnabled("Camp Cuisine: All Hallows Edition","CC2") then
	--id: 187636374
	ch_nm("HALLOWSPICE"," ","plural"," "," ")
	rec.HALLOWSPICE = "   ."
	mk("KANDYKORN"," ")
	mk("SUGARSKULL"," ")
	mk("CANDYAPPLE"," ","it")
	mk("HALLOWEENCANDY","","plural")
end
if IsModEnabled("Camp Cuisine: A Thankful Harvest","CC3") then
	--id: 200885377
	mk("CANDIEDYAM"," ")
	mk_gen("CANDIEDYAM",slang(0,0,"  ."," ."))
	mk("CHALLA"," ")
	mk_gen("CHALLA",slang(0,0,"    .","     !"))
	mk("FAUXTURKEY","","she")
	mk_gen("FAUXTURKEY",slang(0,0,",   ... ."))
	--local fn=function()
	--	  mk("HARVESTSPICE"," "
	--end
	--AddGamePostInit(fn)
	mk("HARVESTSPICE"," ","plural"," "," ")
	--mk_gen(".HARVESTSPICE
	mk("MASHERS"," ","it")
	mk_gen("MASHERS",slang(0,0,"   .","  ."))
	mk("POTATO","","he","",1)
	mk_gen("POTATO",slang(0,0,0,",  ."))
	mk("POTATOBAKED"," ","he"," ",1)
	mk_gen("POTATOBAKED",slang(0,0,0,",   ."))
	mk("POTATO_SEEDS"," ","plural"," ",1)
	--mk_gen(".POTATO_SEEDS
	mk("STUFFING"," ","plural")
	mk_gen("STUFFING",slang(0,0,0,"... ."))
	mk("YAM","")
	mk_gen("YAM",slang(0,0,0,",  "))
	mk("YAM_SEEDS"," ","plural"," ",1)
	--mk_gen(".YAM_SEEDS
	mk_rec("HARVESTSPICE",slang(0,0,"  "))
	
end
if IsModEnabled("Camp Cuisine: A Midwinter Meal","CC4") then
	mk("PUDDING"," ")
	mk_gen("PUDDING",slang(0,0,"  ?")) --,"  ?") --Figgy - "",    . 
	mk("CROWNROAST"," ","it")
	mk_gen("CROWNROAST",slang(0,0,"      !"," !"))
	mk("MINCEMEAT","  ")
	mk_gen("MINCEMEAT",slang(0,0,"      ."," .  ."))
	mk("FESTIVESPICE"," ","plural"," ",1)
	--mk_gen(".FESTIVESPICE = 
	mk_rec("FESTIVESPICE",slang(0,0,0,"   ."))
end

--*******************************************************************************************************************

if IsModEnabled("Pickle It","Pck") then --Pickle It
	--id: 196051302
	mk("RADISH_SEEDS"," ",5," ",1)
	
	
	mk("RADISH","",3)
	mk_gen("RADISH",slang(" .  0.5",0,"   .",
		{"  , ,  ? !","   !",},
		"( 0.5)"))
	
	mk("RADISH_COOKED"," ",3)
	mk_gen("RADISH_COOKED",slang(" 0.5",0," .",
		{"  ","  ,   ",},
		"( 0.5)"))
	
	mk("RADISH_PICKLED"," ")
	mk_gen("RADISH_PICKLED",{", ,  ","     ",})
	
	mk("RADISH_PLANTED","",3) --   
	mk_gen("RADISH_PLANTED",{slang(0,0,"   ",0,"( 0.5)")})
	
	mk("PIGS_FOOT_COOKED","",5)
	mk_gen("PIGS_FOOT_COOKED",slang(0,0," ",{"     "," ,   !"},"( 0.5)"))
	
	mk("PIGS_FOOT_PICKLED", " ", 3)
	mk_gen("PIGS_FOOT_PICKLED",slang(0,0,0, {	
		" ,     ?",
		"  ,       ." }))

	mk("PUMPKIN_PICKLED"," ",3)
	mk_gen("PUMPKIN_PICKLED", {	
		--"Peter Piper pickled a peck of pickled pumpkins... err, peppers", --  
		"    ?\n!"})

	mk("ONION_PLANTED","")
	mk_gen("ONION_PLANTED",slang(0,0,"!  !",0,"( 1 .)"))
	
	mk("ONION_SEEDS"," ",5," ",1)
	
	mk("PICKLE_BARREL"," ",1," ",1)
	AddPrefabPostInit("pickle_barrel",function(inst)
		inst.components.inspectable:SetDescription(function(inst)
			local isPickling = gendesc.PICKLE_BARREL and gendesc.PICKLE_BARREL[1][1]=="I"
			if isPickling == true then
				return RandomString({	
					"   ,  .", 
					"   .", 
					"    ,     ."})
			else
				return RandomString({
					"   , ?", 
					",  .", 
					--"Not to be confused with pickleball", -- 
					"  , ?"})
			end			
		end)
	end)
	
	mk("PIGS_FOOT"," ",3)
	mk_gen("PIGS_FOOT", {	
		",   .",
		"       .",
	})

	mk("MUSH_PICKLED"," ",3)
	mk_gen("MUSH_PICKLED", {	
		"   .", 
		",   ,  .", 
		"˸   ,  ."
	})
	
	mk("ONION","")
	mk_gen("ONION", {	
		"**   ?",
		"  .",
		"-      .",
		"   !",
	})

	mk("ONION_COOKED","  ",5,"  ",1)
	mk_gen("ONION_COOKED", {	
		"   ,      .",
		--"If you hear an onion ring, answer it", -- . ring=  ring=
		" ,       .",
	})
	
	mk("ONION_PICKLED"," ")
	mk_gen("ONION_PICKLED", {	
		" : ,   ?\n !",
		"  ... !",
	})

	
	mk("EGG_PICKLED"," ",5," ",1)
	mk_gen("EGG_PICKLED", {	
		" ,       ?", 
		" ,     ?",
	})

	mk("FISH_PICKLED","",3)
	mk_gen("FISH_PICKLED", {	
		",  !", 
		"  -   .",
		"  ,   .",
	})
	
	mk("MUSHROOM_PICKLED"," ",5)
	mk_gen("MUSHROOM_PICKLED", {	
		--"Why did the fungi leave the party?\nThere wasn't mushroom.",  -- 
		--"Why do people like Mr. Mushroom?\nBecause he's a fungi!", -- 
		"       ?"
	})
	
	mk("CUCUMBER_COOKED"," ",5)
	mk_gen("CUCUMBER_COOKED", {	
		"   .", 
		" ,   .", 
		" ", --   ??
	})
	
	mk("CUCUMBER_PICKLED"," ")
	mk_gen("CUCUMBER_PICKLED", {	
		"  .", 
		--"Why do gherkins giggle? They're PICKLish!", --.    .
		"      ,      .",
	})
	
	mk("CUCUMBER_SEEDS"," ",5," ",1)
	
	mk("EGGPLANT_PICKLED"," ")
	mk_gen("EGGPLANT_PICKLED", {	
		" ,   .",
		"    .",
	})
	
	mk("CABBAGE_SEEDS"," ",5," ",1)
	
	mk("CARROT_PICKLED"," ",3)
	mk_gen("CARROT_PICKLED", {	
		" ,   .", 
		"  ,      - .",
	})
	
	mk("CORN_PICKLED"," ",3)
	mk_gen("CORN_PICKLED", {	
		" ,   ",
		",  ,   .\n     .", --, ?) , 
	})
	
	mk("CUCUMBER","")
	mk_gen("CUCUMBER", slang(" 0.5",0,0, {	
		--"Looks cumbersome... cucumbersome", -- 
		"  ,    .", --, 
		",  ",
		"   ",
		"   !",
	}, "( 0.5)"))
	
	mk("BEET_SEEDS"," ",5," ",1)
	
	mk("CABBAGE","",3)
	mk_gen("CABBAGE", {	
		--"A guy named Cabbage invented the computer... \nno wait, that was Babbage", -- ,  
		"  ,   ", --     ?
		" ,      .",
		"   !",
	})
	
	mk("CABBAGE_COOKED"," ",3)
	mk_gen("CABBAGE_COOKED", {	
		"  ", 
		"  ,    .", 
	})
	
	mk("CABBAGE_PICKLED"," ",3)
	mk_gen("CABBAGE_PICKLED", {	
		"       .", 
		"      .",
		--"Also known as liberty cabbage", -- ? ?
	})
	
	mk("BEET_PICKLED"," ",3)
	mk_gen("BEET_PICKLED", {	
		--"I hear people really like pickled beets.\nMaybe I should give them a try.", 
		"     .",
	})
	
	mk("BEET_PLANTED","",3)
	mk_gen("BEET_PLANTED", {	
		" ... .",
	})
	
	mk("BEET","",3)
	mk_gen("BEET", {	
		":   .", -- , , Battlestar Galactica", --    
		"   .  ,   ?",
		"  ,   ,   .", --, 
		"   !",
	})
	
	mk("BEET_COOKED"," ",3)
	mk_gen("BEET_COOKED", {	
		"     .", 
		"  .", 
	})
end

if IsModEnabled("Storm Cellar") then
	--id: 198485522
	ch_nm("CELLAR","",4,"",1)
	rec.CELLAR = slang(0,"80 ."," ,     , -  .")
	gendesc.CELLAR = "   ."
end
AddConfig({
	{
		name = "Spot",
		label = " ",
		options =
	{
		{description = " ", data = "Default"},
		{description = " ", data = "JustDownSome"},
	},
		default = "Default",
	},
})

--*******************************************************************************************************************

d_rus_mods["Tar"]=0
--if IsModEnabled("TARDIS_1.5","Tar") then --     modinfo,    
if nm.BLUEBOX then --Tardis ~1.5
	--TARDIS 1.5 (Update)
	d_rus_mods["Tar"]=1
	--id: 272586077
	--name: TARDIS_1.5
	--  .   modmain 
	nm.UNKNOWN_PACKAGE = " "
	
	ch_nm("BLUEBOX","","she",1,1,1)
	rec.BLUEBOX = "    ."
	gendesc.BLUEBOX = "  ?"
	
	ch_nm("STATUEHARP"," ","he2"," "," ")
	gendesc.STATUEHARP = " ..."
	
	nm.SCARF = ""
	rec.SCARF  = "?"
	gendesc.SCARF = ", , !"
	
	ch_nm("HAT_FOUR_BW","","she")
	rec.HAT_FOUR_BW = slang(0,0,0," ")
	gendesc.HAT_FOUR_BW = "?"
	
	mk("CUBE"," ",1," ",1)
	mk_gen("CUBE",slang(0,0,0,"   ..."))
	
	mk("WHITEGEM",slang(0,0,"",""),"he",
		slang(0,0,"",""),slang(0,0,1,1))
	mk_gen("WHITEGEM",slang(0,0,0,"   ..."))
	
	mk("WHITESTAFF"," ",1," ",1)
	mk_rec("WHITESTAFF",slang(0,0,0," ..."))
	mk_gen("WHITESTAFF",slang(0,0,0,"  ."))

	--   Packaged -!
--[[	local pack_prefix={" "," "," "," "," "}
	AddPrefabPostInit("package",function(inst)
		if(inst and inst.displaynamefn)then
			inst.displaynamefn=function(inst)
				--inst.components.packer.package.prefab
				local pk = inst.components.packer
				local pref = pk.package and pk.package.prefab
				--local basename = pk:GetName()
				local basename=pref and nm[string.upper(pref)]
				if pref and basename then
					local gender=1
					--if (_G.NamesGender["he2"][pref]) then gender=2
					if (_G.NamesGender["she"][pref]) then gender=3
					elseif (_G.NamesGender["it"][pref]) then gender=4
					elseif (_G.NamesGender["plural"][pref]) then gender=5
					end
					if _G.russiannames[basename] then -- 
					end
					return pack_prefix[gender]..basename
				else
					err("(pref="..tostring(pref)..", basename="..tostring(basename)..")")
					return " "
				end
			end
		end
	end)]]
	
end

--*******************************************************************************************************************

if IsModEnabled("Minimap HUD","mMH") then --Minimap HUD--
	--id: 188251898
	--      Minimap HUD.
	AddClassPostConstruct("widgets/minimapwidget", function(self)
		self.Old_Open=self.SetOpen
		local function makeRus(self)
			if self.togglebutton then
				local txt=self.togglebutton:GetText()
				if (txt=="Close Minimap") then
					self.togglebutton:SetText("")
				elseif (txt=="Open Minimap") then
					self.togglebutton:SetText("")
				end
			end
		end
		local function SetOpen2(self, state)
			self:Old_Open(state)
			makeRus(self)
		end
		self.SetOpen=SetOpen2
		makeRus(self)
	end)
end
AddConfig({
    {
        name = "Minimap Size",
		label = " ",
        options =
        {
            {description = "", data = 0.125},
            {description = "", data = 0.175},
            {description = "", data = 0.225},
            {description = "", data = 0.275},
            {description = "", data = 0.325},
            {description = "", data = 0.375},
        },
        default = 0.225,
    },
    {
        name = "Position",
		label = "",
        options =
        {
            {description = " ", data = "top_right"},
            {description = " ", data = "top_left"},
            {description = "  ", data = "top_center"},
            {description = " ", data = "middle_left"},
            {description = "  ", data = "middle_center"},
            {description = " ", data = "middle_right"},
            {description = " ", data = "bottom_left"},
            {description = "  ", data = "bottom_center"},
            {description = " ", data = "bottom_right"},
        },
        default = "top_right"
    },
    {
        name = "Horizontal Margin",
		label = " ",
        options =
        {
            {description = slang(0,"0",""), data = 0},
            {description = slang(0,"5"," "), data = 5},
            {description = slang(0,"12.5",""), data = 12.5},
            {description = slang(0,"25"," "), data = 25},
            {description = slang(0,"50",""), data = 50},
            {description = slang(0,"125",""), data = 125},
            {description = slang(0,"235",""), data = 235},
            {description = slang(0,"350",""), data = 350},
            {description = slang(0,"450",""), data = 450},
        },
        default = 235
    },
    {
        name = "Vertical Margin",
		label = " ",
        options =
        {
            {description = slang(0,"0",""), data = 0},
            {description = slang(0,"5"," "), data = 5},
            {description = slang(0,"12.5",""), data = 12.5},
            {description = slang(0,"25"," "), data = 25},
            {description = slang(0,"50",""), data = 50},
            {description = slang(0,"125",""), data = 125},
            {description = slang(0,"235",""), data = 235},
            {description = slang(0,"300"," "), data = 300},
            {description = slang(0,"350",""), data = 350},
            {description = slang(0,"450",""), data = 450},
        },
        default = 25
    },
})

--*******************************************************************************************************************

if IsModEnabled("Beefalo Milk","Mlk") then --Beefalo Milk and Cheese--
	--if(GetGlobal("ACTIONS")and rawget(ACTIONS,"MILK")then
	--AddPostInit(function()
	--	_G.ACTIONS["MILK"].str = "" --still doesn't work 
	--end)
	_G.ACTIONS["MILK"].str = "" --this doesn't work 
	s.ACTIONS["MILK"] = ""		 --and this works!

	--end
	gen.ANNOUNCE_KICK = "!   !"

	ch_nm("RAWMILK"," ","it")
	ch_nm("COOKEDMILK"," ","it")
	nm.CHEESE = ""
	ch_nm("BERRYSHAKE","- ",1,"- ",1)

	gendesc.RAWMILK = slang(0,0,"  .","    ,    .")
	gendesc.COOKEDMILK = ", ."
	gendesc.CHEESE = "     ."
	gendesc.BERRYSHAKE = "  ."

	wendy.BERRYSHAKE = slang(0,0,"   ,  .","  ,  .")
	wicker.BERRYSHAKE = "       ."
	willow.BERRYSHAKE = "   .  ."
	wolfgang.BERRYSHAKE = "    ."
	wx78.BERRYSHAKE = "     ."
	maxwell.BERRYSHAKE = "   ." 
	woodie.BERRYSHAKE = "   . ,  , ."
	
	wendy.RAWMILK = "     ."
	wicker.RAWMILK = "  ."
	willow.RAWMILK = "    ."
	wolfgang.RAWMILK = ", ,  ."
	wx78.RAWMILK = "    ."
	maxwell.RAWMILK = ", ." 
	woodie.RAWMILK = "    , ?"
	
	wendy.COOKEDMILK = "-     ."
	wicker.COOKEDMILK = "    ."
	willow.COOKEDMILK = "  ."
	wolfgang.COOKEDMILK = " ."
	wx78.COOKEDMILK = " ."
	maxwell.COOKEDMILK = "    ."
	woodie.COOKEDMILK = "       ."

	wendy.CHEESE = "   ."
	wicker.CHEESE = ",     ."
	willow.CHEESE = " +  = ."
	wolfgang.CHEESE = "    ."
	wx78.CHEESE = "    ."
	maxwell.CHEESE = "   ."
	woodie.CHEESE = "   ."

	if(DLC)then
		wath.BERRYSHAKE = " !       ,    ." 
		webber.BERRYSHAKE = "      !" -- ?

		wath.RAWMILK = "       !"
		webber.RAWMILK = " ,     ."

		wath.COOKEDMILK = "  ."
		webber.COOKEDMILK = "  ?"

		wath.CHEESE = " ,   ."
		webber.CHEESE = "    ,     ."
	end
end

if IsModEnabled("Waiter 101","Wt") then --Waiter 101--
	--id: 255930840
	ch_nm("SAUSAGE_GRAVY","   ",5) --"Sausage and Gravy"
	gendesc.SAUSAGE_GRAVY = "    ."
	wx78.SAUSAGE_GRAVY = "  =  "
	woodie.SAUSAGE_GRAVY = "    ."
	willow.SAUSAGE_GRAVY = " ,  ."
	wolfgang.SAUSAGE_GRAVY = "     .."
	wendy.SAUSAGE_GRAVY = "   - ."
	wicker.SAUSAGE_GRAVY = "    ."
	
	nm.MUSHROOM_BURGER = " " --"Mushroom Burger"
	gendesc.MUSHROOM_BURGER = "    ."
	wx78.MUSHROOM_BURGER = " /  / "
	woodie.MUSHROOM_BURGER = slang(0,0,"   ... ?","   , ?")
	willow.MUSHROOM_BURGER = " ?"
	wolfgang.MUSHROOM_BURGER = "   !"
	wendy.MUSHROOM_BURGER = "   ."
	wicker.MUSHROOM_BURGER = "    ."

	ch_nm("SURF_N_TURF"," ",3) --"Surf and Turf Platter"
	gendesc.SURF_N_TURF = " ,  ."
	wx78.SURF_N_TURF = "    "
	woodie.SURF_N_TURF = ",      !"
	willow.SURF_N_TURF = ",   ."
	wolfgang.SURF_N_TURF = "   ."
	wendy.SURF_N_TURF = "   ."
	wicker.SURF_N_TURF = "     ."

	ch_nm("STICKY_BUN"," ",3) --"Sticky Bun"
	gendesc.STICKY_BUN = "   ."
	wx78.STICKY_BUN = " "
	woodie.STICKY_BUN = slang(0,0,"  .","  , ?")
	willow.STICKY_BUN = "  ."
	wolfgang.STICKY_BUN = "  ."
	wendy.STICKY_BUN = slang(0,0,"    .","  .")
	wicker.STICKY_BUN = "    ."
	
	ch_nm("MUSHROOM_STEW","   ",5) --"Creamy Mushrooms"
	gendesc.MUSHROOM_STEW = "  ."
	wx78.MUSHROOM_STEW = "   "
	woodie.MUSHROOM_STEW = " ."
	willow.MUSHROOM_STEW = ",   ."
	wolfgang.MUSHROOM_STEW = " ."
	wendy.MUSHROOM_STEW = "   ."
	wicker.MUSHROOM_STEW = "   ."

	ch_nm("NUT_BUTTER"," ",4) --"Birchnut Butter"
	gendesc.NUT_BUTTER = "  ."
	wx78.NUT_BUTTER = "  Ĩ  "
	woodie.NUT_BUTTER = "   !"
	willow.NUT_BUTTER = "    ."
	wolfgang.NUT_BUTTER = "!    !"
	wendy.NUT_BUTTER = slang(0,0,"  .","  .")
	wicker.NUT_BUTTER = "     ."

	nm.CHEESE_LOG = "   " --"Nutty Cheese Log."
	gendesc.CHEESE_LOG = slang(0,0,0,"  ,   .") --" ,   ." -- , log=
	wx78.CHEESE_LOG = "  "
	woodie.CHEESE_LOG = " ,      ." --   
	willow.CHEESE_LOG = "  ,  ,    ." --  :(
	wolfgang.CHEESE_LOG = "   ."
	wendy.CHEESE_LOG = "   ." --,    ?
	wicker.CHEESE_LOG = "    \"Uova di beefala\" ( )." --  

	nm.NANA_BREAD = " " --"Banana Bread"
	gendesc.NANA_BREAD = " ,   ."
	wx78.NANA_BREAD = "  "
	woodie.NANA_BREAD = " !"
	willow.NANA_BREAD = "  ,  ."
	wolfgang.NANA_BREAD = "    ."
	wendy.NANA_BREAD = "  ."
	wicker.NANA_BREAD = ", ,  ,   ."
	
	ch_nm("CHOWDER"," ",1," ",1) --"Seafood Chowder"
	gendesc.CHOWDER = "  ."
	wx78.CHOWDER = "    "
	woodie.CHOWDER = "  -  ."
	willow.CHOWDER = "  ."
	wolfgang.CHOWDER = "  ."
	wendy.CHOWDER = "    ."
	wicker.CHOWDER = "      ." 
	
	nm.GUMBO = "   " --"Spicy Gumbo"
	gendesc.GUMBO = "   ."
	wx78.GUMBO = "  = "
	woodie.GUMBO = "      ?"
	willow.GUMBO = "   ."
	wolfgang.GUMBO = "  -  ."
	wendy.GUMBO = "   ."
	wicker.GUMBO = slang(0,0,"  .","      .")  --.....
	
	--"Sweet and Sour Pork"
	ch_nm("SWEET_N_SOUR","- ",3,"- ","- ") 
	gendesc.SWEET_N_SOUR = slang(0,0,"   .","      .")
	wx78.SWEET_N_SOUR = "  "
	woodie.SWEET_N_SOUR = "    ."
	willow.SWEET_N_SOUR = "  ."
	wolfgang.SWEET_N_SOUR = "     -   ."
	wendy.SWEET_N_SOUR = "  ,    ."
	wicker.SWEET_N_SOUR = "        ." 
	
	ch_nm("BEEFALO_WINGS"," ",5) --"Beefalo Wings"
	gendesc.BEEFALO_WINGS = "   ."
	wx78.BEEFALO_WINGS = "   ?"
	woodie.BEEFALO_WINGS = "   , ?" 
	willow.BEEFALO_WINGS = "   ." --"Meat treat heat." --  
	wolfgang.BEEFALO_WINGS = "     ."
	wendy.BEEFALO_WINGS = "  ."
	wicker.BEEFALO_WINGS = slang(0,0,"     .","    .")
	
	ch_nm("CANDIED_FRUIT","",5) --"Candied Fruit"
	gendesc.CANDIED_FRUIT = "   ."
	wx78.CANDIED_FRUIT = "  "
	woodie.CANDIED_FRUIT = " ."
	willow.CANDIED_FRUIT = "   ."
	wolfgang.CANDIED_FRUIT = ",  ."
	wendy.CANDIED_FRUIT = ",    ."
	wicker.CANDIED_FRUIT = "    ."
	
	ch_nm("CANDIED_NUT","  ",5,"  ","  ") --"Sugared Nuts"
	gendesc.CANDIED_NUT = "   ."
	wx78.CANDIED_NUT = "   "
	woodie.CANDIED_NUT = " ."
	willow.CANDIED_NUT = "   ."
	wolfgang.CANDIED_NUT = " ."
	wendy.CANDIED_NUT = "   ."
	wicker.CANDIED_NUT = "     ."

	ch_nm("MUSHROOM_MEDLEY"," ",1) --"Mushroom Medley"
	gendesc.MUSHROOM_MEDLEY = "    ."
	wx78.MUSHROOM_MEDLEY = "  "
	woodie.MUSHROOM_MEDLEY = "    !"
	willow.MUSHROOM_MEDLEY = "   ."
	wolfgang.MUSHROOM_MEDLEY = "   ."
	wendy.MUSHROOM_MEDLEY = " ."
	wicker.MUSHROOM_MEDLEY = "      ."

	ch_nm("MUSHROOM_MALODY"," ",3," "," ") --"Mushroom Malody"
	gendesc.MUSHROOM_MALODY = "  ."
	wx78.MUSHROOM_MALODY = " "
	woodie.MUSHROOM_MALODY = "   ?"
	willow.MUSHROOM_MALODY = "   ?"
	wolfgang.MUSHROOM_MALODY = "  ."
	wendy.MUSHROOM_MALODY = "  ."
	wicker.MUSHROOM_MALODY = "   ."
	
	nm.OMELETTE = " " --"Fluffy Omelette"
	gendesc.OMELETTE = "    ."
	wx78.OMELETTE = slang(0,0," ","  ")
	woodie.OMELETTE = " , ?"
	willow.OMELETTE = "Ƹ    ."
	wolfgang.OMELETTE = "     ?"
	wendy.OMELETTE = "Whipped and beaten."
	wicker.OMELETTE = "  ."
	
	ch_nm("MUSHY_EGGS","-",3) --"Mushy Eggs"
	gendesc.MUSHY_EGGS = " ."
	wx78.MUSHY_EGGS = "  "
	woodie.MUSHY_EGGS = " ,  ."  --   
	willow.MUSHY_EGGS = "   ."
	wolfgang.MUSHY_EGGS = "   ,    ."
	wendy.MUSHY_EGGS = "    ." --,  ...     .
	wicker.MUSHY_EGGS = "  ."
	
	nm.MUSH_MELON = " " --"Mushmelons"
	gendesc.MUSH_MELON = "     ."
	wx78.MUSH_MELON = "   " --   
	woodie.MUSH_MELON = "  ."
	willow.MUSH_MELON = "  ,   ."
	wolfgang.MUSH_MELON = "     ."
	wendy.MUSH_MELON = "̸   ,   - ."
	wicker.MUSH_MELON = "  ."

	ch_nm("COLDCUTS"," ",4) --"Coldcuts" --    "cold",        
	gendesc.COLDCUTS = "  ."
	wx78.COLDCUTS = "  "
	woodie.COLDCUTS = "    ."
	willow.COLDCUTS = ". ,   ?"
	wolfgang.COLDCUTS = "˸     ."
	wendy.COLDCUTS = " ."
	wicker.COLDCUTS = " ,   ."

	-- RoG Enabled Characters
	if DLC then 
		wath.SAUSAGE_GRAVY = "  ,    ."
		wath.MUSHROOM_BURGER = "  ."
		wath.SURF_N_TURF = "    ."
		--wath.SURF_N_TURF = "Twice the meat in one feast." --
		wath.STICKY_BUN = "   ."
		wath.MUSHROOM_STEW = " ,   ."
		wath.NUT_BUTTER = "  ,    ."
		wath.CHEESE_LOG = "       ."
		wath.NANA_BREAD = "  ."
		wath.CHOWDER = " ,   ."
		wath.GUMBO = "."
		wath.SWEET_N_SOUR = " ."	
		wath.BEEFALO_WINGS = "!  !"	 --  "beefy" 
		wath.CANDIED_FRUIT = "   ."
		wath.CANDIED_NUT = "   ."
		wath.MUSHROOM_MEDLEY = ",      ."
		wath.MUSHROOM_MALODY = ",      ."
		wath.OMELETTE = "   ." --  
		wath.MUSHY_EGGS = "  ."
		wath.MUSH_MELON = "  ,    ."
		wath.COLDCUTS = "   ."
		
		--  
	end
end



--*******************************************************************************************************************

-- LINK THE HERO --
STRINGS=GLOBAL.STRINGS
if IsModEnabled("Link","Lnk") then --Link, The Hero
	--id: 179124884
	-- Legal STRINGS
	
	s.CHARACTER_TITLES.link = ""
	s.CHARACTER_NAMES.link = ""
	s.CHARACTER_DESCRIPTIONS.link = slang(0,0,"* .\n* .\n* !","*.\n*.\n*... .")
	s.CHARACTER_QUOTES.link = slang(0,0,"\" !\"","\" , !\"")
	
	ch_nm("LINKSWORD"," ","he"," ",1,1) --  
gendesc.LINKSWORD = slang(0,0,
	"   ,        .",
	" ,       .","( 51)")
	--nm.OCARINA = slang(0,0,0," ") --???
	ch_nm("OCARINA"," ",3,0,0,1)
	gendesc.OCARINA = slang(0,0,"  ."," ,        .","(,    )")
	ch_nm("SHIELD"," ",1," ",1,1)
	gendesc.SHIELD = " ,    ."
	ch_nm("LINKERANG"," ",1," ",1,1)
	gendesc.LINKERANG = " ,      ."
	nm.WOODSWORD = " "
	gendesc.WOODSWORD = "  ."
	rec.WOODSWORD = "  ."
	nm.WDSHIELD = " "
	gendesc.WDSHIELD = "  ."
	rec.WDSHIELD = "  ."
	ch_nm("MEGTON"," ",1," ",1,1)
	gendesc.MEGTON = " ,  .     ,     ."
	ch_nm("HEROLAN"," ",1," ",1,1)
	gendesc.HEROLAN = "  , capable of expelling small bursts of fire to ignite flammable objects."
	ch_nm("TUNIC_RED"," ",3)
	gendesc.TUNIC_RED = " ."
	ch_nm("TUNIC_BLUE"," ",3)
	gendesc.TUNIC_BLUE = "  ."
	ch_nm("TRULENS"," ",3) --"Hero's Lens of Truth"
	gendesc.TRULENS = " ,   ,   ."
	ch_nm("BUNNYHOOD"," ",1," ",1)
	gendesc.BUNNYHOOD = "    ,        ."
	nm.BOTTLE_E = " "
	gendesc.BOTTLE_E = "    -."
	ch_nm("BOTTLE_R"," ",4)
	gendesc.BOTTLE_R = "  ."
	rec.BOTTLE_R = "  ."
	ch_nm("BOTTLE_G"," ",4)
	gendesc.BOTTLE_G = "  ."
	rec.BOTTLE_G = "  ."
	ch_nm("BOTTLE_B"," ",4)
	gendesc.BOTTLE_B = "      ."
	rec.BOTTLE_B = "      ."
	ch_nm("DINROCK"," ",1," ",1,1) --Din.   , .. 
	gendesc.DINROCK = " ,     ."
	ch_nm("FARORROCK"," ",1," ",1,1)
	gendesc.FARORROCK = " ,     ."
	ch_nm("NAYRUROCK"," ",3," ",1,1)
	gendesc.NAYRUROCK = " ,     ."
	ch_nm("BOMBS","",5)
	gendesc.BOMBS = " ,   ! !"
	rec.BOMBS = "  .    ."
	ch_nm("FAIRY","",3,1,1,1)
	gendesc.FAIRY = "   -  !" 
	ch_nm("ARROWS","",5)
	gendesc.ARROWS = "   ."
	rec.ARROWS = "   .   - 10 ."
	ch_nm("RUPEE","",1,1,1)
	gendesc.RUPEE = " !   ..."
	s.ACTIONS.MARK = "   "
	s.ACTIONS.RECALL = "    "
	s.ACTIONS.RESET = "   "

	s.TABS.HERO = "" --  :  
	
	AddPostInit(function()
		ch.LINK=require "rus_link"
	end, "link")
end
if IsModEnabled("Link - OoT Names","LnkP") then
	--small patch
	--id: 220011987
	ch_nm("LINKSWORD"," ",1," ",1,1)
	ch_nm("OCARINA"," ",3,0,0,1)
	ch_nm("SHIELD"," ",1," ",1) --"Hylian Shield"
	ch_nm("LINKERANG"," ",1," ",1,1)
	ch_nm("MEGTON"," ",1," ",1) --"Megaton Hammer"
	nm.HEROLAN = ""
	ch_nm("TUNIC_RED"," ",3," "," ")
	ch_nm("TUNIC_BLUE"," ",3," "," ")
	--nm.TRULENS = " " --same
	--nm.BUNNYHOOD = " " --same
	ch_nm("FAIRY","",3,1,1,1)
end


--*******************************************************************************************************************

if IsModEnabled("Chocolate","Cho") or nm.CHOCO_COOKIES then
	--id: 293230292
	ch_nm("CACAO"," ") --   "!
	ch_nm("CACAO_COOKED","","it",1,1) --  " "
	nm.CHOCOLATE = ""
	ch_nm("CACAO_TREE"," ","it")
	nm.CHOCOLATE_MILK = " "
	ch_nm("CHOCO_ICECREAM"," ","she")
	ch_nm("CHOCO_COOKIES"," ","it")

	local grow="( 8 )"
	
	gendesc.CACAO = " .      ."
	gendesc.CACAO_COOKED = "   !"
	gendesc.CHOCOLATE = " !"
	gendesc.CACAO_TREE = slang(0,0,0,"   !",grow)
	gendesc.CHOCOLATE_MILK = slang(0,0," !","    !")
	gendesc.CHOCO_ICECREAM = "   !" --  
	gendesc.CHOCO_COOKIES = slang(0,0,"    !"," !")

	--- Willow ---
	willow.CACAO = " ...    ."
	willow.CACAO_COOKED = " ,  ."
	willow.CHOCOLATE = "    ."
	willow.CACAO_TREE = slang(0,0,"  ...  .","     .",grow)
	willow.CHOCOLATE_MILK = slang(0,0,".    .",".    .")
	willow.CHOCO_ICECREAM = "     ."
	willow.CHOCO_COOKIES = " !!"

	--- Wolfgang ---
	wolfgang.CACAO = "     !"
	wolfgang.CACAO_COOKED = slang(0,0,",  ."," .")
	wolfgang.CHOCOLATE = "     ."
	wolfgang.CACAO_TREE = slang(0,0,0,"    .    .",grow)
	wolfgang.CHOCOLATE_MILK = slang(0,0,0,"   !")
	wolfgang.CHOCO_ICECREAM = "    !"
	wolfgang.CHOCO_COOKIES = "   ."

	--- Wendy ---
	wendy.CACAO = ",      ."
	wendy.CACAO_COOKED = slang(0,0," ","  .")
	wendy.CHOCOLATE = "  !"
	wendy.CACAO_TREE = slang(0,0," ,     .","     .",grow)
	wendy.CHOCOLATE_MILK = "    ."
	wendy.CHOCO_ICECREAM = " ...   ."
	wendy.CHOCO_COOKIES = "     ."

	--- WX-78 ---
	wx78.CACAO = "ƨ  ."
	wx78.CACAO_COOKED = " ,    ?"
	wx78.CHOCOLATE = slang(0,0,"   ","   .")
	wx78.CACAO_TREE = slang(0,0,"  ","  ",grow)
	wx78.CHOCOLATE_MILK = "    ."
	wx78.CHOCO_ICECREAM = "   ."
	wx78.CHOCO_COOKIES = "   ."

	--- Wickerbottom ---
	wicker.CACAO = "     ."
	wicker.CACAO_COOKED = "     ."
	wicker.CHOCOLATE = " , , , ,   ."
	wicker.CACAO_TREE = slang(0,0,"      .","     .",grow)
	wicker.CHOCOLATE_MILK = slang(0,0,"     ,   .",
		"       .")
	wicker.CHOCO_ICECREAM = slang(0,0,"  ,  .","  ,   .")
	wicker.CHOCO_COOKIES = " . ,    ."

	--- Woodie ---
	woodie.CACAO = "   ?"
	woodie.CACAO_COOKED = "  ,    ."
	woodie.CHOCOLATE = slang(0,0,"       !","      !")
	woodie.CACAO_TREE = slang(0,0,0,"   ...    .",grow)
	woodie.CHOCOLATE_MILK = slang(0,0,"   -  .","    .")
	woodie.CHOCO_ICECREAM = slang(0,0,"       .","       .")
	woodie.CHOCO_COOKIES = "    ."

	--- Waxwell ---
	maxwell.CACAO = slang(0,0,"   ,    .",0)
	maxwell.CACAO_COOKED = " ...   ."
	maxwell.CHOCOLATE = " -    ."
	maxwell.CACAO_TREE = slang(0,0,0,"     .   .",grow)
	maxwell.CHOCOLATE_MILK = "!   ."
	maxwell.CHOCO_ICECREAM = "...    ."
	maxwell.CHOCO_COOKIES = "   ."

	if DLC then 
		--- Wigfrid ---
		wath.CACAO = "    ."
		wath.CACAO_COOKED = slang(0,0,"     !","  ,    !")
		wath.CHOCOLATE = ",             ."
		wath.CACAO_TREE = "    !"
		wath.CHOCOLATE_MILK = "   ,     !"
		wath.CHOCO_ICECREAM = "  ,   !"
		wath.CHOCO_COOKIES = slang(0,0," .    .","   ,    .")

		--- Webber ---
		webber.CACAO = "     ."
		webber.CACAO_COOKED = "     ."
		webber.CHOCOLATE = slang(0,0,"     !","  !")
		webber.CACAO_TREE = slang(0,0,"     .","      !",grow)
		webber.CHOCOLATE_MILK = "     ."
		webber.CHOCO_ICECREAM = "     !"
		webber.CHOCO_COOKIES = "-!"
	end
end
AddConfig({
	{
        name = "Cacao_CookedHP",
        label = ", HP",
        options =
        {
            {description = "-1", data = -1},
            {description = "0", data = 0},			
            {description = "+3", data = 3},
       },
        default = -1,
    },	
    {
        name = "ChocolateHP",
        label = ", HP",
        options =
        {
            {description = "-3", data = -3},
            {description = "0", data = 0},			
            {description = "+10", data = 10},
			{description = "+20", data = 20},
       },
        default = -3,
    },
    {
        name = "Chocolate_MilkHP",
        label = " , HP",
        options =
        {
            {description = "-3", data = -3},
            {description = "0", data = 0},			
            {description = "+10", data = 10},
			{description = "+20", data = 20},
       },
        default = -3,
    },	
	    {
        name = "Chocolate_MilkTEMP",
        label = ", ",
        options =
        {
            {description = "+40", data = 40},
            {description = "0", data = 0},
       },
        default = 40,
    },	
	    {
        name = "Choco_IcecreamHP",
        label = ". , HP",
        options =
        {
            {description = "0", data = 0},
            {description = "-3", data = -3},			
            {description = "+10", data = 10},
       },
        default = 0,
    },	
		    {
        name = "Choco_IcecreamTEMP",
        label = ". ., ",
        options =
        {
            {description = "-20", data = -20},
            {description = "-40", data = -40},
       },
        default = -20,
    },	
		{
        name = "Choco_CookiesHP",
        label = ". , HP",
        options =
        {
            {description = "0", data = 0},
            {description = "-3", data = -3},			
            {description = "+10", data = 10},
       },
        default = 0,
    },	
})

if IsModEnabled("Wren the Stormcaller","Ren") then
	-- id: 177537243
	ch_nm("LIGHTSTAFF"," ",1," ",1)
	rec.LIGHTSTAFF = slang("-15   .\n -10% ",0,0,"   !"," (-15   , -10% )")
	s.CHARACTERS.GENERIC.DESCRIBE.LIGHTSTAFF = slang(0,0,"     !",
		"  ,     .","(-15 )")

	s.CHARACTER_TITLES.wren = ""
	s.CHARACTER_NAMES.wren = "Wren"
	s.CHARACTER_DESCRIPTIONS.wren = "* .\n*      .\n*  ."
	s.CHARACTER_QUOTES.wren = "\" ,  , -  ?\""
	AddPostInit(function()
		s.CHARACTERS.WREN = require "rus_wren"
	end, "wren")
end

if IsModEnabled("Whimsy the Goth","Whm") then
	--id: 289099215
	s.CHARACTER_TITLES.whimsy = ""
	s.CHARACTER_NAMES.whimsy = "" --"Whimsy"
	s.CHARACTER_DESCRIPTIONS.whimsy = slang(0,0,"* .\n*   .\n* ,   .",
		"* .\n*   .\n* ,    .")
	--"*Creature of the night.\n*Hates sunshine and getting wet.\n*Skilled in magic, but hates icky things."
	s.CHARACTER_QUOTES.whimsy = "\"' '..     ?\""
	--s.CHARACTERS.WHIMSY = require "speech_whimsy"

	
	ch.WHIMSY = require "rus_whimsy"
	
	--  ,  
	local whimsy_config=GetModConfigData("whimsy")
	AddPostInit(function()
		if whimsy_config>1 then
			StructCopy(ch.GENERIC,ch.WHIMSY) -- GENERIC
			if whimsy_config==3 then
				StructCopy(ch.WENDY,ch.WHIMSY) --  
			end
		end
	end, "whimsy")


	nm.WHIMSY_UMBRELLA = " " -- +
	gendesc.WHIMSY_UMBRELLA = " ,   ."
	wx78.WHIMSY_UMBRELLA = "    "

	nm.WHIMSY_NIGHT_UMBRELLA = " "
	gendesc.WHIMSY_NIGHT_UMBRELLA = "   ."
	wx78.WHIMSY_NIGHT_UMBRELLA = "  "
	rec.WHIMSY_NIGHT_UMBRELLA = "    ."

	nm.WHIMSY_AWFUL_UMBRELLA = " "
	gendesc.WHIMSY_AWFUL_UMBRELLA = slang(0,0,"     .",
		"    .")
	wx78.WHIMSY_AWFUL_UMBRELLA = "  "
	rec.WHIMSY_AWFUL_UMBRELLA = "    ."
end
AddConfig({
    {
        name = "magicAffinity",
        label = " ",
        options =
        {
            {description = "", data = 0},
            {description = "", data = 2},
            {description = " ", data = 3},
        },
        default = 0,
    },
	{
        name = "ancientAffinity",
        label = "  ",
        options =
        {
            {description = "", data = 0},
            {description = "", data = 2},
            {description = "", data = 4},
        },
        default = 0,
    },
	{
        name = "umbrellaLevel",
        label = " ",
        options =
        {
            {description = "", data = nil},
            {description = "", data = "umbrella"},
            {description = "", data = "whimsy_umbrella"},
            {description = "", data = "whimsy_night_umbrella"},
        },
        default = "whimsy_umbrella",
    },
	{
        name = "daySanityDrain",
        label = "  ",
        options =
        {
            {description = "", data = 5},
            {description = "", data = 10},
            {description = "", data = 20},
        },
        default = 5,
    },
	{
        name = "magicRegenFactor",
        label = "  ",
        options =
        {
            {description = "", data = 0.00001},
            {description = "10 ", data = 10},
            {description = "30 ", data = 30},
            {description = "60 ", data = 60},
            {description = "", data = nil},
        },
        default = 10,
    },
	{
        name = "magicCostFactor",
        label = "  ()",
        options =
        {
            {description = "", data = 0},
            {description = "1/8 ", data = 1.0/8.0},
            {description = "1/4 ", data = 1.0/4.0},
            {description = "1/2 ", data = 1.0/2.0},
            {description = " ", data = 1},
        },
        default = 1.0/4.0,
    },
	{
        name = "easyResurrect",
        label = " ",
        options =
        {
            {description = "", data = false},
            {description = "", data = true},
        },
        default = false,
    },
	{
        name = "complainRate",
        label = "  ",
        options =
        {
            {description = "", data = 0},
            {description = "5 ", data = 0.05},
            {description = "10 ", data = 0.1},
            {description = "25 ", data = 0.25},
            {description = "50 ", data = 0.5},
            {description = "", data = 1},
        },
        default = 0.1,
    },
})

if IsModEnabled("Satori","Sat") then
	--id: 240990229
s.CHARACTER_TITLES.sat = "" --"The Mind Reader"
s.CHARACTER_NAMES.sat = ""  -- Note! This line is especially important as some parts of the game require
-- the character to have a valid name.
s.CHARACTER_DESCRIPTIONS.sat = "*  .\n*  .\n*,   ." --"*Can read minds\n*Animals love her"
s.CHARACTER_QUOTES.sat = slang(0,0,"\"     .\"",
	"\"      .\"")

--AddPostInit(function() --   .

STRINGS.ACTIONS.STAYORDER = " " --Stay
STRINGS.ACTIONS.STAYORDER_CANCEL = "" -- Follow


--    (- ).
act.STAYORDER.fn = function(act)
	local targ = act.target
	if targ and targ.components.staycommand then
		act.doer.components.locomotor:Stop()
		act.doer.components.talker:Say(slang(0,0," .",",  ."))
		targ.components.staycommand:SetStaying(true)
		targ.components.staycommand:RememberStayPos("stayspot", _G.Point(targ.Transform:GetWorldPosition())) 
	return true
	end
end

act.STAYORDER_CANCEL.fn = function(act)
	local targ = act.target
	if targ and targ.components.staycommand then
	act.doer.components.locomotor:Stop()
		act.doer.components.talker:Say(slang(0,0," .","  ."))
		targ.components.staycommand:SetStaying(false)
		return true
	end
end

local function ModMaxwellIntro(inst)
	if _G.GetPlayer().prefab == "sat" then
		local sandbox=inst.components.maxwelltalker.speeches.SANDBOX_1
		sandbox[1]["string"] = slang(0,",     .",
			",   ?     .",
			",     .")
		sandbox[1].wait = 3
		sandbox[2]["string"] = slang(0,"      ,      .",
			" , ?    ,      .",
			"  - ,      !")
		sandbox[2].wait = 5
	end
end
AddPrefabPostInit("maxwellintro", ModMaxwellIntro)



--   Satori 
local satoriChat={
	-- 
	["Yummy!"]="!",
	["Mommy?"]="?",
	["Hurts!"]="!",
	["Food!"]="!",
	["Mommy! Help!"]="! !",
	["I'm starting to like you."]="   ",
	["Don't leave me behind."]="  .",
	["It hurts! Do something!"]="!  -!",
	["Food...food! FOOD!"]="... ! !",
	["Hey! Don't touch her!"]="!   !",
	-- 
	["We are herd now."]="    - .",
	["Remember Satori, we are herd."]=", ,     - .",
	["Assimilate into the herd."]="  .",
	["Join us."]="  .",
	["Resistance is futile."]=slang(0,0,"        .",
		" ."),
	["We are beefalo, we are the herd."]=" - ,  - .",
	["I wait here."]=slang(0,0,"    .","   ."),
	["Wait for moo!"]=slang(0,0," ,    !"," -!"),
	["It hurts!"]="!",
	["I need food!"]="  !",
	["Give grass or you're forever alone!"]=slang(0,0," ,      !",
		" ,     !"),
	["I'll protect you!"]=slang(0,0,"  !","   !"),
	["Don't touch her!"]=slang(0,0,"    !","  !"),
	["Stay back!"]=" !",
	["Can't stay with you anymore!"]=slang(0,0,"  !","     !"),
	-- 
	["I SAID DON'T TOUCH EGG!"]=slang(0,0,0," ,   !"),
	["MUST PROTECT EGG!"]=slang(0,0," Ψ !","   "),
	["New egg is coming."]="   .",
	["Friend don't touch egg."]=",   .",
	["Eye person looks nice."]=slang(0,0,"   .   .","   ."),
	--  ()
	["DON'T TOUCH HER!"]="  Ũ!",
	["SHE'S MINE!"]=slang(0,0,"  !"," !"),
	["COME BACK HERE!"]=slang(0,0,0,"!"), --  
	["FEED ME! NOW!"]=" !  !",
	["I GOT HURT!"]="  !",
	["THIS IS YOUR FAULT"]=slang(0,0,"   ","  "),
	["Don't go too far!"]="   !",
	["We will always be together!"]="   !",
	["My lovely partner!"]=slang(0,0," !","   !"),
	["WHERE ARE YOU GOING?!"]=slang(0,0,"  ?!","  Ĩ?!"),
	["DON'T YOU DARE LEAVE ME"]="   ",
	["WHO IS THIS!?"]=" ?",
	["AM I NOT GOOD ENOUGH FOR YOU?!"]=slang(0,0,"    ?",
		"      ?"),
	--
	["SCARY EYE MONSTER!"]=slang(0,0,"!  !","! !"),
	["DIE! EYE MONSTER!"]=slang(0,0,"! !","! !"),
	["MY HEAD! YOU GO SMASH!"]=slang(0,0,"   !"," ! Ѩ - !"),
	["STAY OUT OF MY HEAD!"]="   !",
	["EVIL EYE! GO AWAY!"]=slang(0,0,"  !"," ! !"),
	["MY HOUSE!"]="  !",
	["YOU SMASH HOUSE, I SMASH HEAD!!"]=slang(0,0,"   !!",
		"  ,    !!"),
	["YOU MONSTER!"]="  !",
	--
	["Delicious!"]=" !",
	["I'm hungry!"]=" !",
	["I'm late! I'm late!"]=slang(0,0,",  ,  !   ", --  
		" !  !"),
	["Dark soon! Run home!"]=" !  !",
	["Scary dark!"]=slang(0,0,"   !"," !"),
	["Carrot?"]="?",
	["Carrot where?"]=" ?",
	["Scary?"]="?", --  ?
	-- 
	["I'm not lonely anymore."]="   .",
	["Don't leave me."]="  .",
	["Stay close to me."]="   .",
		["Did you forget about feeding me?"]="    ?",
	["I'm not feeling well..."]="   ...",
	["I don't like fighting!"]="   !",
	["Don't hurt my friend!"]="   !",
	["I thought we were friends!"]=" ,   !",
	-- 
	["Like you!"]=slang(0,0," !","  !"),
	["Wait!"]="!",
	["Hungry!"]=slang(0,0," !","!"),
	["Ow!"]=slang(0,0,"!","!"),
	["No carrot!? Bye!"]=slang(0,0," ? !"," ?  !"),
	--LEIF ??
	["MURDERER!"]="!",
	["MONSTER!"]=slang(0,0," !","!"),
	["I'LL MAKE YOU PAY!"]="   Ѩ!",
	--
	["I say!"]=slang(0,0,"!","  ."), --?
	["Doth the lady protest?"]=slang(0,0,"   ?","  ?"),
	["Indubitably."]=slang(0,0,"  .","."),
	["Good day, m'lady."]=" , .",
	["Eggcellent."]="!", -- ?
	--  (   )
	["Friend, why!?"]=slang(0,0,",   ?!",", ?!"),
	["I'm scared! Stop!"]=slang(0,0,"! , !"," ! , !"),
	["I'm lonely."]=slang("    ...    .","  ...    .","  ...",0),
	["Are you friend?"]=slang(" ?      ?"," ?  - ?"," ?",0),
	["Why do you use food as light?"]=slang(0,"     ?   .",0,"     ?"), --???
	["The plant I like doesn't hatch."]=slang(0,",   ,     .",0,",   ,   ."), --???
	--  
	["Oh, grass."]=", .",
	["I feel safe with my herd."]="       .",
	["How could you!?"]="  ?",
	["Why this?"]=" ?",
	--["It hurts!"]= -- 
	["Who are you?"]=" , ?",
	["Friend?"]="?",
	["You look nice."]="  .",
	-- 
	["Oh, nice beefalo."]=", , .",
	["I want a partner."]=slang(0,0,"  .","  ."),
	["You not beefalo!"]="  !",
	["Go away!"]=slang(0,0," !","!"),
	
	
}

--     ?
--if(GetGlobal("ChattyNode")) then
AddPostInit(function()
	ch.SAT=require "rus_sat"
	local oldChatFunc=_G.ChattyNode.Visit
	_G.ChattyNode.Visit=function(self)
		if(not self.trans)then
			self.trans=true
			for k,v in pairs(self.chatlines) do
				if(satoriChat[v]) then self.chatlines[k]=satoriChat[v] end
			end
		end
		oldChatFunc(self)
	end
end, "sat")
--end


--jj:  Tasty   beefalo.lua



--""   -  STRINGS     .
mk("PETKOALEFANT_SUMMER"," ","he2"," "," ")
mk_gen("PETKOALEFANT_SUMMER",slang(0,0,0,"    ..."))

mk("PETKOALEFANT_WINTER"," ","he2"," "," ")
mk_gen("PETKOALEFANT_WINTER",slang(0,0,0,"    ..."))

--gen. = "     ."

--,     -   .
mk("PETRABBIT"," ",2," "," ")
mk_gen("PETRABBIT","   .    .")


--     
local petrabbit_Strings={
	["my pet rabbit"]=" ",
	["pet rabbit"]=" ",
	["What is this?! Where did my rabbit go?!"]=" ?     ?",
	["So precious and naive. I want to hug it."]=slang(0,0," !    !",
		"   .    ."),
}
local function petrabbit_prefab(inst)
	local function RusPetRabbit()
		--_G.print("BEFORE: "..gendesc.PETRABBIT)
		nm.PETRABBIT = petrabbit_Strings[nm.PETRABBIT] or nm.PETRABBIT
		gendesc.PETRABBIT = petrabbit_Strings[gendesc.PETRABBIT] or gendesc.PETRABBIT
		--_G.print("AFTER: "..gendesc.PETRABBIT)
	end
	local old_SetOnDroppedFn=inst.components.inventoryitem.ondropfn
	inst.components.inventoryitem:SetOnDroppedFn(function(inst)
		_G.print("OnDrop")
		old_SetOnDroppedFn(inst)
		RusPetRabbit()
	end)
	local old_OnEntityWake=inst.OnEntityWake
	inst.OnEntityWake = function(inst)
		_G.print("OnWake")
		old_OnEntityWake(inst)
		RusPetRabbit()
	end
	local old_OnEntitySleep=inst.OnEntitySleep
	inst.OnEntitySleep = function(inst)
		_G.print("OnSleep")
		old_OnEntitySleep(inst)
		RusPetRabbit()
	end
	local old_OnLoad = inst.OnLoad
	inst.OnLoad = function(inst, data)
		_G.print("OnLoad")
		old_OnLoad(inst,data)
		RusPetRabbit()
	end
	
	local old_CheckTransformState = inst.CheckTransformState
	inst.CheckTransformState = function(inst)
		_G.print("CheckTransformState")
		old_CheckTransformState(inst)
		RusPetRabbit()
	end
	RusPetRabbit()
	--        :
	local watchForever; watchForever=function(inst)
		inst:DoTaskInTime(1,watchForever)
		RusPetRabbit()
	end
	inst:DoTaskInTime(1,watchForever)
end
AddPrefabPostInit("petrabbit", petrabbit_prefab)

mk("PETTALLBIRD","  ","she","  ","  ")
mk_gen("PETTALLBIRD",slang(0,0," ,   - ."," ,    ."))

mk("PETBEEFALO"," ","he2"," "," ")
mk_gen("PETBEEFALO",slang(0,0,"  .","    ."))


--	end, "sat")
end
AddConfig({
    {
        name = "Music",
        label = "",
        options =
        {
            {description = " ", data = "not"},
            {description = " ", data = "sat"}
        },
        default = "basic_mode",
    },
})


if IsModEnabled("Not quite Pyro","Pyro") then
	s.CHARACTER_TITLES.pyro = ""
	s.CHARACTER_NAMES.pyro = "Pyro"
	s.CHARACTER_DESCRIPTIONS.pyro = "*  .\n*   .\n*  ,     ."
	s.CHARACTER_QUOTES.pyro = "\" .\"" --Fire with fire.


		mk("PYROAXE"," ",1," ",1)
		mk_rec("PYROAXE"," !")
		mk_gen("PYROAXE", {	
			"  ?",
			" .",
		})

		mk("FLAREGUN"," ") --"Cold Flare Gun"
		mk_rec("FLAREGUN","    !")
		mk_gen("FLAREGUN", {	
			"   .",
			" ."
		})
		
		mk("FLARELIGHT"," ")
		mk_gen("FLARELIGHT", {	
			"  !",
		})

	
	AddPostInit(function()

		
		ch.PYRO = require "rus_pyro"

		--  ,   ( )
		local pyro_config=GetModConfigData("pyro")
		if pyro_config>1 then
			--StructCopy(ch.GENERIC,ch.PYRO) -- GENERIC
			if pyro_config==3 then
				StructCopy(ch.WILLOW,ch.PYRO) --  
			end
		end
		
		
		
	end, "pyro")
end


if IsModEnabled("Cookable Ham Bat","Ham") then
	nm.BACON = ""
	gendesc.BACON = " ,!"
end

if IsModEnabled("Advanced Farming","Adv") then
	--id: 254465969
	nm.G_HOUSE = "" --"Advance Farm"
	rec.G_HOUSE = "  !"
	gendesc.G_HOUSE = "     !"

	ch_nm("HYBRID_BANANA_TREE"," ",4) --"Hybrid Banana Tree"
	--rec.HYBRID_BANANA_TREE = " It's an agricultural breakthrough!"
	gendesc.HYBRID_BANANA_TREE = "   !"

	ch_nm("HYBRID_BANANA_SEEDS"," ",5," ",1)
	rec.HYBRID_BANANA_SEEDS = "  ."
	gendesc.HYBRID_BANANA_SEEDS = "    !"

	ch_nm("HYBRID_BANANA","",5)
	nm.HYBRID_BANANA_COOKED = " "
	gendesc.HYBRID_BANANA = "  !"
	gendesc.HYBRID_BANANA_COOKED = "  !"
end


if IsModEnabled("Clockwork Tooth Trap","Che") then
	--id: 201702468
  ch_nm("CLOCKWORK_TRAP_TEETH"," ",3) --"Clockwork Tooth Trap"
  rec.CLOCKWORK_TRAP_TEETH = slang(0,
	"55 \n21 \n8   ","     ",0)
  gendesc.CLOCKWORK_TRAP_TEETH = slang(0,"  55   21 ? ."," .",0)
end

if IsModEnabled("Endothermic Torch","EndT") then
	--id: 242975503
	ch_nm("ENDOTHERMIC_TORCH"," ",1," ",1)
	rec.ENDOTHERMIC_TORCH = "   ."
	gendesc.ENDOTHERMIC_TORCH = "       ."
end

if IsModEnabled("Lunch Box","LnB") then
	--id: 200842586
	nm.LUNCH_BOX = "-"
	rec.LUNCH_BOX = " "
	gendesc.LUNCH_BOX = "!"
end

if IsModEnabled("Eyebrella","Eye") then
	--id: 249995995
	nm.EYEBRELLA = ""
	rec.EYEBRELLA = slang(0,0,"     .","   !","(  55%)")
	gendesc.EYEBRELLA = "    !"
end


if IsModEnabled("Porta-Grill","PG") then
	--id: 248047614
	nm.GRILL = " "
	rec.GRILL = "   ."
	gendesc.GRILL = "!"
end

if IsModEnabled("Spider Cage","PG") then
	--id: 264098865
	nm.SILK_FARM = " "
	rec.SILK_FARM = "     ."
	gendesc.SILK_FARM = ",    !"

	nm.SILK_FARM_ADVANCED = "  "
	rec.SILK_FARM_ADVANCED = "ظ    ."
	gendesc.SILK_FARM_ADVANCED = "    !" --??
end
AddConfig({
    {
 name = "Gold Nuggets", 
 label = " ",
		options = 
	{
		{description = "1", data = 1},
		{description = "2", data = 2},
		{description = "4", data = 4},
		{description = "8", data = 8}
	},
		default = 2
},

	{
 name = "Spider Eggs", 
 label = " ",
		options = 
	{
		{description = "1", data = 1},
		{description = "2", data = 2},
	},
		default = 1
},

    {
name = "Boards", 
label = "",
		options = 
	{
		{description = "1", data = 1},
		{description = "2", data = 2},
		{description = "4", data = 4},
		{description = "8", data = 8},
	},
		default = 4
	},

    {
name = "Mode", 
label = "",
		options = 
	{
		{description = "", data = "on"},
		{description = "", data = "off"}
	},
		default = "off"
	},	
})

if IsModEnabled("Wall Gates","WG") then
	--id: 196994731
	nm.MECH_HAY_ITEM = " "
	rec.MECH_HAY_ITEM = "  ."

	nm.MECH_WOOD_ITEM = " "
	rec.MECH_WOOD_ITEM = "  ."

	nm.MECH_STONE_ITEM = " "
	rec.MECH_STONE_ITEM = "  ."

	nm.MECH_RUINS_ITEM = " "
	rec.MECH_RUINS_ITEM = "  ."

	nm.MECH_HAY = nm.MECH_HAY_ITEM
	nm.MECH_WOOD = nm.MECH_WOOD_ITEM
	nm.MECH_STONE = nm.MECH_STONE_ITEM
	nm.MECH_RUINS = nm.MECH_RUINS_ITEM

	gendesc.MECH_HAY = " !"
	gendesc.MECH_WOOD = " !"
	gendesc.MECH_STONE = " !"
	gendesc.MECH_RUINS = " !"

	gendesc.MECH_HAY_ITEM = "-!"
	gendesc.MECH_WOOD_ITEM = "-!"
	gendesc.MECH_STONE_ITEM = "-!"
	gendesc.MECH_RUINS_ITEM = "-!"
end

if IsModEnabled("Aqvarium","Aq") then
	--id: 271860275
    nm.AQVARIUM = ""
	rec.AQVARIUM = " "
	gendesc.AQVARIUM = ",  ..."
end

if IsModEnabled("WX-Overhaul","WX") then
	--id: 179287930
	s.TABS.UPGRADES = ""

	ch_nm("HEALTHUP",slang(0,0,"-18"," "),"it")  --"Armor Plating Module"
	ch_nm("SANITYUP","",1) --"CPU Module"
	ch_nm("HUNGERUP"," ",1)
	ch_nm("LOCOMOTORUP",slang(0,0," ","LSM"),1,slang(0,0," ",1),1)
	ch_nm("COMBATUP",slang(0,0," ","ECM"),1,slang(0,0," ",1),1)
	ch_nm("COMBATDOWN",slang(0,0," "," LSM"),slang(0,0,3,4),slang(0,0," "," LSM"),slang(0,0," ",1))
	ch_nm("LOCOMOTORDOWN",slang(0,0," "," ECM"),slang(0,0,1,4))
	ch_nm("STATUS"," ",1," ",1)
	nm.PENCIL = ""

	rec.HEALTHUP = slang(0,0," ."," .  .","  20.")
	rec.SANITYUP = slang(0,0,0,".   HD .","+10 .")
	rec.HUNGERUP = slang(": +15",
		"   15."," .     .",0)
	rec.LOCOMOTORUP = slang(0,"+10% \n+20%  \n: 5",
		" ,    .",0)
	rec.COMBATUP = slang(0,":+20%\n: -10%\n: 5",
		" ,    .","*  -   *.")
	rec.COMBATDOWN =slang(0,0,"    .","   LSM")
	rec.LOCOMOTORDOWN =slang(0,0,"    .","   ECM")
	rec.STATUS = slang(0,0,"   .","   .")
	rec.PENCIL = slang(0,0,"   .")

	wx78.HEALTHUP = "   ...  "
	wx78.SANITYUP = "   .   ... -."
	wx78.HUNGERUP = "     "
	wx78.LOCOMOTORUP = slang(0,0," -   ...  ",
		" -   ...   ")
	wx78.COMBATUP = slang(0,0,"   ","   ")
	wx78.LOCOMOTORDOWN = " -    ()"
	wx78.COMBATDOWN = "   "
	wx78.STATUS = "   .     ˨."
	wx78.PENCIL = "   "
	
	local WX78_CHAT={
		["srs?"]="?",
		["AT CAPACITY. UPGRADE FAILED"]=".  .",
		["DOWNGRADE FAILED. NO UPGRADE DETECTED"]="  .  .",
		--[[["Armor " .. health_level .. "/10" ..  "\n" ..
			"Sanity " .. sanity_level .. "/10" .. "\n" .. 
			"Hunger " .. hunger_level .."/10" .. "\n" .. 
			"Locomotor " .. locomotor_level .."/5" .. "\n" .. 
			"Combat " .. combat_level .."/5"]=
			
			slang(0,0,"","") .. health_level .. "/10" ..  "\n" .. 
			" " .. sanity_level .. "/10" .. "\n" .. 
			" " .. hunger_level .."/10" .. "\n" .. 
			" " .. locomotor_level .."/5" .. "\n" .. 
			" " .. combat_level .."/5",--]]
	}
	
	--   WX-78,  
	AddPostInit(function()
		local talker=player and player.components and player.components.talker or {Say=function() end}
		local oldChatFunc=talker.Say
		talker.Say=function(self,script,tm,noanim)
			if(type(script)=="string")then
				if WX78_CHAT[script] then script=WX78_CHAT[script]
				elseif string.sub(script,1,5)=="Armor" then --     
					local health_level = tostring(math.min(player.health_level,10))
					local sanity_level = tostring(math.min(player.sanity_level,10))
					local hunger_level = tostring(math.min(player.hunger_level,10))
					local locomotor_level = tostring(math.min(player.locomotor_level,5))
					local combat_level = tostring(math.min(player.combat_level,5))
					script=slang(0,0,"","") .. health_level .. "/10" ..  "\n" .. 
						" " .. sanity_level .. "/10" .. "\n" .. 
						" " .. hunger_level .."/10" .. "\n" .. 
						" " .. locomotor_level .."/5" .. "\n" .. 
						" " .. combat_level .."/5"
				end
			end
			oldChatFunc(self,script,tm,noanim)
		end
	end, "wx78")
end
AddConfig({
    {
        name = "opt",
        label = " ",
        options = 
        {
            {description = "", data = "standard"}, 
            {description = "˸", data = "easy"}
        }, 
        default = "standard",
    }
})


if IsModEnabled("Dawnbreak","Db") then
	ch_nm("GOLDENBUTTERFLY"," ",3)
	gendesc.GOLDENBUTTERFLY = { GENERIC = " !" }
end

if IsModEnabled("Season Clock","SC") then
	--id: 298407615
	AddPostInit(function()
		for k,v in pairs(player.HUD.controls.sidepanel.children) do
			if (tostring(v)=="SeasonClock") then
				local oldFunc = v.GenerateCurrentSeasonClockString
				v.GenerateCurrentSeasonClockString = function(self)
					local c_seasons={
						[""]="",
						[""]="",
						[""]="",
						[""]="",
					}
					local s=oldFunc(self)
					local daysIn, currentSeason, daysLeft, nextSeason =
						string.match(s,"(%d+) days into (.+)%.\r(%d+) days until (.+)%.")
					if daysIn and currentSeason and daysLeft and nextSeason then
						s=StringTime(daysIn,"").." "..tostring(c_seasons[currentSeason])..".\r"
							..StringTime(daysLeft,"").."  "..tostring(c_seasons[nextSeason]).."."
						return s
					end
					return s
				end
			end
		end
	end,true)
end
AddConfig({
	{
		name = "autumn_color",
		label = " ",
		options = {
						{description = "Ƹ", data = "lightyellow"},
						{description = "", data = "yellow"},
						{description = "", data = "lightgreen"},
						{description = "", data = "green"},
						{description = "", data = "lightred"},
						{description = "", data = "red"},
						{description = "", data = "lightblue"},
						{description = "", data = "blue"},
					},

		default = "lightred",
	
	},
	{
		name = "winter_color",
		label = " ",
		options = {
						{description = "Ƹ", data = "lightyellow"},
						{description = "", data = "yellow"},
						{description = "", data = "lightgreen"},
						{description = "", data = "green"},
						{description = "", data = "lightred"},
						{description = "", data = "red"},
						{description = "", data = "lightblue"},
						{description = "", data = "blue"},
					},

		default = "lightblue",
	
	},
	{
		name = "spring_color",
		label = " ",
		options = {
						{description = "Ƹ", data = "lightyellow"},
						{description = "", data = "yellow"},
						{description = "", data = "lightgreen"},
						{description = "", data = "green"},
						{description = "", data = "lightred"},
						{description = "", data = "red"},
						{description = "", data = "lightblue"},
						{description = "", data = "blue"},
					},

		default = "green",
	
	},
	{
		name = "summer_color",
		label = " ",
		options = {
						{description = "Ƹ", data = "lightyellow"},
						{description = "", data = "yellow"},
						{description = "", data = "lightgreen"},
						{description = "", data = "green"},
						{description = "", data = "lightred"},
						{description = "", data = "red"},
						{description = "", data = "lightblue"},
						{description = "", data = "blue"},
					},

		default = "yellow",
	
	},
	{
		name = "hovertextoption",
		label = " ",
		options = {
						{description = "", data = "detailed"},
						{description = "", data = "brief"},
						{description = "", data = "off"},
					},

		default = "detailed",
	},
	{
		name = "hoverfontsize",
		label = "  ",
		options = {
						{description = " ", data = "verysmall"},
						{description = "", data = "small"},
						{description = "", data = "default"},
						{description = "", data = "large"},
						{description = " ", data = "verylarge"},
					},

		default = "default",
	},

	{
		name = "seasonfontsize",
		label = "  ",
		options = {
						{description = " ", data = "verysmall"},
						{description = "", data = "small"},
						{description = "", data = "default"},
						{description = "", data = "large"},
						{description = " ", data = "verylarge"},
					},
		default = "default",
	},

	{
		name = "showincave",
		label = " ",
		options = {
						{description = "", data = true},
						{description = "", data = false},
					},
		default = true,
	},

	{
		name = "texttodisplay",
		label = " ",
		options = {
						{description = " ", data = "currentseason"},
						{description = " ", data = "seasonprogress"},
						{description = "", data = "off"},
					},
		default = "currentseason",
	},

	{
		name = "clockposition",
		label = "",
		options = {
						{description = " ", data = "aboveday"},
						{description = " ", data = "belowday"},
						{description = "  ", data = "leftofday"},
						{description = "  ", data = "rightofday"},
					},
		default = "rightofday",
	},
})

if IsModEnabled("Wilson's House With Light") then
	--id: 177826455
    ch_nm("WILSON_HOUSE_LIGHT","  ",3)
    rec.WILSON_HOUSE_LIGHT = ",  !"
    gendesc.WILSON_HOUSE_LIGHT = "     ."
end

if IsModEnabled("Always On Status") then
	--id: 180843799
end
AddConfig({
	{
		name = "Naughtiness_state",
		label = "",
		options =	{
						{description = "", data = "default"},
						{description = "", data = "off"},
					},

		default = "default",
	
	},
	
	{
		name = "Temperature_state",
		label = " ",
		options =	{
						{description = "", data = "default"},
						{description = "", data = "off"},
					},

		default = "default",
	
	},
	
	{
		name = "Temperature_Unit",
		label = " ",
		options =	{
						{description = "", data = "default"},
						{description = "", data = "fahrenheit"},
					},

		default = "default",
	
	},
})

if IsModEnabled("Haunted House") then
	--id: 188454908
	nm.WITCH_HAT = " "
    nm.HAUNTED_HOUSE = "  "

    rec.WITCH_HAT = "  "
    rec.HAUNTED_HOUSE = "!"

    gendesc.WITCH_HAT = "!"
    gendesc.HAUNTED_HOUSE = "."
end

if IsModEnabled("Fish Farm") then
	--id: 203330260
	ch_nm("W_POND"," ",3)
	rec.W_POND = "     ."
	gendesc.W_POND = slang(0,0,",   ?    ?",",  ,  ?")
end

if IsModEnabled("Wilson's Cabin") then
	--id: 207754436
	ch_nm("WILSON_CABIN",slang(0,0,""," "),3,slang(0,0,""," "),
		slang(0,0,""," "))
	rec.WILSON_CABIN = ",  !"
    gendesc.WILSON_CABIN = " ,   ."
end

if IsModEnabledNoVer("Deluxe Campfires 1.03") then
	--id: 269073510
	ch_nm("DELUXE_FIREPIT"," ",4," ",1)
	rec.DELUXE_FIREPIT = slang(0," .",",     .",
		" ,     ,   !")
 
	gendesc.DELUXE_FIREPIT  =
	{
		OUT = "  ,   ,    .",
		EMBERS = "  ,    .",
		LOW = "   .",
		NORMAL = "      4   ...",
		HIGH = ",       ,    .",
	}

	wx78.DELUXE_FIREPIT  =
	{
		OUT = "   !",
		EMBERS = "  !",
		LOW = "",
		NORMAL = "    ",
		HIGH = ":   ",
	}

	wolfgang.DELUXE_FIREPIT  =
	{
		OUT = ", !",
		EMBERS = " !",
		LOW = "        .",
		NORMAL = "  .",
		HIGH = ",   !   !",
	}

	willow.DELUXE_FIREPIT  =
	{
		OUT = ", ...",
		EMBERS = "  ,   .",
		LOW = "  .",
		NORMAL = " ...   ,  !",
		HIGH = "------! !",
	}

	maxwell.DELUXE_FIREPIT  =
	{
		OUT = "  ,  -  .",
		EMBERS = ", ,   .",
		LOW = "     .",
		NORMAL = "... !",
		HIGH = "  ,     -!",
	}

	wicker.DELUXE_FIREPIT  =
	{
		OUT = "- .",
		EMBERS = " ,    ...",
		LOW = "   .",
		NORMAL = "     .",
		HIGH = ",     !",
	}

	wendy.DELUXE_FIREPIT  =
	{
		OUT = "  ,   .",
		EMBERS = "    .",
		LOW = "    .",
		NORMAL = "   .",
		HIGH = "  ,      .",
	}

	woodie.DELUXE_FIREPIT  =
	{
		OUT = ", ,    .",
		EMBERS = "     , ...",
		LOW = "    ,     .",
		NORMAL = "     ,     .",
		HIGH = ",    ...   !",
	}

	if DLC then 
		wath.DELUXE_FIREPIT  =
		{
			OUT = "fn gn!.",
			EMBERS = "vn th mt is ffndd by this wk fir!",
			LOW = "This is ky",
			NORMAL = "din himslf wld b prd of this fir!",
			HIGH = "vn the grt and mighty din wld b scrd of this fir!!",
		}

		webber.DELUXE_FIREPIT  =
		{
			OUT = ".",
			EMBERS = "  .",
			LOW = "    .",
			NORMAL = "  ,   .",
			HIGH = " ,    ,  .",
		}
	end
end
AddConfig({
    {
        name = "deluxeFirepitBurnRate",
        label = " ",
        options =
        {
            {description = "25%%  ", data = 0.75},
            {description = "50%%  ", data = 0.5},
             {description = "75%%  ", data = 0.25}
       },
        default = 0.75,
    },
    {
        name = "recipeCost",
        label = "",
        options =
        {
            {description = "", data = "cheap"},
            {description = "", data = "standard"},
            {description = "", data = "expensive"}
      },
        default = "standard",
    },
    {
        name = "dropLoot",
        label = " ?",
        options =
        {
            {description = "", data = "no"},
            {description = "", data = "yes"}
      },
        default = "yes",
    },
})

if IsModEnabled("Simple HUD") then
	--id: 286844464
end
AddConfig({
	{
		name="displaytemperature",
		label="",
		options=
		{
			{description = "", data=true},
			{description = "", data=false},
		},
		default=true
	},
	{
		name="finstead",
		label="",
		options=
		{
			{description = "", data=false},
			{description = "", data=true},
		},
		default=false
	},
	{
		name="numberalpha",
		label="",
		options=
		{
			{description = "100", data=1},
			{description = "90", data=.9},
			{description = "80", data=.8},
			{description = "70", data=.7},
			{description = "60", data=.6},
			{description = "50", data=.5},
			{description = "40", data=.4},
			{description = "30", data=.3},
			{description = "20", data=.2},
			{description = "10", data=.1},
			{description = "OFF", data=0},
		},
		default=1
	},
	{
		name="numbercolorclock",
		label=" ",
		options=
		{
			{description = "", data={1,1,1}},
			{description = "", data={1,0,0}},
			{description = "", data={0,1,0}},
			{description = "", data={0,0,1}},
			{description = "", data={0,1,1}},
			{description = "", data={1,0,1}},
			{description = "Ƹ", data={1,1,0}},
			{description = "׸", data={0,0,0}},
		},
		default={1,1,1}
	},
	{
		name="numbercolortop",
		label=" ",
		options=
		{
			{description = "", data={1,1,1}},
			{description = "", data={1,0,0}},
			{description = "", data={0,1,0}},
			{description = "", data={0,0,1}},
			{description = "", data={0,1,1}},
			{description = "", data={1,0,1}},
			{description = "Ƹ", data={1,1,0}},
			{description = "׸", data={0,0,0}},
		},
		default={1,1,1}
	},
	{
		name="numbercolorbottom",
		label=" ",
		options=
		{
			{description = "", data={1,1,1}},
			{description = "", data={1,0,0}},
			{description = "", data={0,1,0}},
			{description = "", data={0,0,1}},
			{description = "", data={0,1,1}},
			{description = "", data={1,0,1}},
			{description = "Ƹ", data={1,1,0}},
			{description = "׸", data={0,0,0}},
		},
		default={1,1,1}
	},
	{
		name="numbercolorrain",
		label=" ",
		options=
		{
			{description = "", data={1,1,1}},
			{description = "", data={1,0,0}},
			{description = "", data={0,1,0}},
			{description = "", data={0,0,1}},
			{description = "", data={0,1,1}},
			{description = "", data={1,0,1}},
			{description = "Ƹ", data={1,1,0}},
			{description = "׸", data={0,0,0}},
		},
		default={1,1,1}
	},
	{
		name="enablecustomcolor",
		label=" ",
		options=
		{
			{description = " ", data=false},
			{description = "", data=true},
		},
		default=false
	},
	{
		name="ccred",
		label=" ",
		options=
		{
			{description = "100", data=1},
			{description = "90", data=.9},
			{description = "80", data=.8},
			{description = "70", data=.7},
			{description = "60", data=.6},
			{description = "50", data=.5},
			{description = "40", data=.4},
			{description = "30", data=.3},
			{description = "20", data=.2},
			{description = "10", data=.1},
			{description = "0", data=0},
		},
		default=1
	},
	{
		name="ccgreen",
		label=" ",
		options=
		{
			{description = "100", data=1},
			{description = "90", data=.9},
			{description = "80", data=.8},
			{description = "70", data=.7},
			{description = "60", data=.6},
			{description = "50", data=.5},
			{description = "40", data=.4},
			{description = "30", data=.3},
			{description = "20", data=.2},
			{description = "10", data=.1},
			{description = "0", data=0},
		},
		default=1
	},
	{
		name="ccblue",
		label=" ",
		options=
		{
			{description = "100", data=1},
			{description = "90", data=.9},
			{description = "80", data=.8},
			{description = "70", data=.7},
			{description = "60", data=.6},
			{description = "50", data=.5},
			{description = "40", data=.4},
			{description = "30", data=.3},
			{description = "20", data=.2},
			{description = "10", data=.1},
			{description = "0", data=0},
		},
		default=1
	},
	{
		name="enableadapttopcolor",
		label="  ()",
		options=
		{
			{description = "OFF", data=false},
			{description = "ON", data=true},
		},
		default=false
	},
	{
		name="makerainbow",
		label=" ",
		options=
		{
			{description = "", data=false},
			{description = "", data=true},
		},
		default=false
	},
})

--***************************************************************************************************************

--  ,       
local oldIndex = _G.ModIndex.InitializeModInfo
_G.ModIndex.InitializeModInfo = function (a,modname,c)
	local env = {}
	env.GAMELANGUAGE = _G.GAMELANGUAGE
	env.MOD_NAMES=mod_names
	local fn = _G.kleiloadlua("../mods/"..modname.."/modinfo.lua")
	local modinfo_message = ""
	if type(fn) == "string" then
		env.failed = true
	elseif not fn then
		modinfo_message = modinfo_message.."  modinfo.lua,  ... "
		env.old = true
	else
		local status, r = _G.RunInEnvironment(fn,env)

		if status == false then
			env.failed = true
		elseif env.api_version == nil or env.api_version < _G.MOD_API_VERSION then
			modinfo_message = modinfo_message.." API! (: "..tostring(env.api_version).." : ".._G.MOD_API_VERSION..") "
			env.old = true
		elseif env.api_version > _G.MOD_API_VERSION then
			env.failed = true
		else
			local checkinfo = { "name", "description", "author", "version", "forumthread", "api_version",
			} --"dont_starve_compatible", "reign_of_giants_compatible", "configuration_options" }
			local missing = {}

			for i,v in ipairs(checkinfo) do
				if env[v] == nil then
					table.insert(missing, v)
				end
			end

			if #missing > 0 then
				env.failed = true
			end
		end
	end

	env.modinfo_message = modinfo_message

	-- If modinfo hasn't been updated to specify compatibility yet, set it to true for both modes and set a flag
	if env.dont_starve_compatible == nil then
		env.dont_starve_compatible = true
		env.dont_starve_compatibility_specified = false
	end
	if env.reign_of_giants_compatible == nil then
		env.reign_of_giants_compatible = true
		env.reign_of_giants_compatibility_specified = false
	end
	
	--     .
	if env.name and conf_options[env.name] and not env.NO_NEED_TRANSLATE_RUS
		and env.configuration_options and type(env.configuration_options)=="table" then
		local ln = math.min(#(conf_options[env.name]),#(env.configuration_options))
		for i=1,ln do
			if conf_options[env.name][i].name == env.configuration_options[i].name then
				env.configuration_options[i].label = conf_options[env.name][i].label
				env.configuration_options[i].options = conf_options[env.name][i].options --dump
			end
		end
	end

	return env
	--return oldIndex(a,modname,c)
end


-- ,      
--  
local after_start=0 --   .
local player_name; -- 
function DoAfterALL()
	after_start=after_start+1
	if(after_start~=2) then
		return false -- 
	end
	after_start=3 --    
	for k,v in pairs(glob_nm) do
		nm[k]=v
	end
	for k,v in pairs(glob_rec) do
		rec[k]=v
	end
	for k,v in pairs(glob_gen) do
		gendesc[k]=v
	end
	for i=1,#post_init_fns do
		--   ,      
		if (not post_init_fns[i][2]) or post_init_fns[i][2]==player_name
			or (post_init_fns[i][2]==true and player_name and player_name~="" and player) then
			post_init_fns[i][1]();
			--logg('+')
		--elseif (not post_init_fns[i][2]) then logg('no2')
		--elseif post_init_fns[i][2]~=player.prefab then logg('noname='..player_name)
		end
	end
end


-- Start    .    2    .
local OldStart=GLOBAL.Start
local function PostInitRusStrings()
	OldStart()
	DoAfterALL()
end
GLOBAL.Start=PostInitRusStrings;
--AddGamePostInit(PostInitRusStrings)

--   
AddSimPostInit(function(inst)
	player=inst
	player_name=inst.prefab
	DoAfterALL()
	GetGlobal("player_name",inst.prefab)
	--[[
	if AOS or true then --   Always On Status
		--player.HUD.controls.status.owner.components.switch.T_unit
		if player.HUD and player.HUD.controls and player.HUD.controls.status
		and player.HUD.controls.status.owner and player.HUD.controls.status.owner.components then
			if not player.HUD.controls.status.owner.components.switch then
				local switch = Class(function(self)
					self.T_onoff = 1; self.N_onoff = 1; self.T_unit = 1;
				end)
				function switch:OnSave()
					return {T_onoff = self.T_onoff,N_onoff = self.N_onoff,T_unit = self.T_unit}
				end
				function switch:OnLoad(data)
					self.T_onoff = data.T_onoff or self.T_onoff
					self.N_onoff = data.N_onoff or self.N_onoff
					self.T_unit = data.T_unit or self.T_unit
				end
				player:AddComponent("switch")
				err("No switch")
			else
				err("Switch ok")
			end
		else
			err("No such component")
		end
	end
	--]]
end)




--DEBUG
local s_rus_mods=""
for k,v in pairs(d_rus_mods) do
	s_rus_mods=s_rus_mods..(v and "+" or "-")..k..", "
end
_G.rus_mods=s_rus_mods


end --  if not is_rus



_G.rus_errors=function() _G.p(errors) end
_G.stat=function() return status end






























